package com.hai.dao;

import com.hai.entity.BsMsgUser;
import com.hai.entity.BsMsgUserExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsMsgUserMapper extends BsMsgUserMapperExt {
    @SelectProvider(type=BsMsgUserSqlProvider.class, method="countByExample")
    long countByExample(BsMsgUserExample example);

    @DeleteProvider(type=BsMsgUserSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsMsgUserExample example);

    @Delete({
        "delete from bs_msg_user",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_msg_user (msg_id, user_id, ",
        "user_name, user_phone, ",
        "where_check, check_time, ",
        "create_time, update_time, ",
        "ext_1, ext_2, ext_3)",
        "values (#{msgId,jdbcType=VARCHAR}, #{userId,jdbcType=BIGINT}, ",
        "#{userName,jdbcType=VARCHAR}, #{userPhone,jdbcType=VARCHAR}, ",
        "#{whereCheck,jdbcType=BIGINT}, #{checkTime,jdbcType=TIMESTAMP}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsMsgUser record);

    @InsertProvider(type=BsMsgUserSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsMsgUser record);

    @SelectProvider(type=BsMsgUserSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="msg_id", property="msgId", jdbcType=JdbcType.VARCHAR),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="user_name", property="userName", jdbcType=JdbcType.VARCHAR),
        @Result(column="user_phone", property="userPhone", jdbcType=JdbcType.VARCHAR),
        @Result(column="where_check", property="whereCheck", jdbcType=JdbcType.BIGINT),
        @Result(column="check_time", property="checkTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsMsgUser> selectByExample(BsMsgUserExample example);

    @Select({
        "select",
        "id, msg_id, user_id, user_name, user_phone, where_check, check_time, create_time, ",
        "update_time, ext_1, ext_2, ext_3",
        "from bs_msg_user",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="msg_id", property="msgId", jdbcType=JdbcType.VARCHAR),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="user_name", property="userName", jdbcType=JdbcType.VARCHAR),
        @Result(column="user_phone", property="userPhone", jdbcType=JdbcType.VARCHAR),
        @Result(column="where_check", property="whereCheck", jdbcType=JdbcType.BIGINT),
        @Result(column="check_time", property="checkTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsMsgUser selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsMsgUserSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsMsgUser record, @Param("example") BsMsgUserExample example);

    @UpdateProvider(type=BsMsgUserSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsMsgUser record, @Param("example") BsMsgUserExample example);

    @UpdateProvider(type=BsMsgUserSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsMsgUser record);

    @Update({
        "update bs_msg_user",
        "set msg_id = #{msgId,jdbcType=VARCHAR},",
          "user_id = #{userId,jdbcType=BIGINT},",
          "user_name = #{userName,jdbcType=VARCHAR},",
          "user_phone = #{userPhone,jdbcType=VARCHAR},",
          "where_check = #{whereCheck,jdbcType=BIGINT},",
          "check_time = #{checkTime,jdbcType=TIMESTAMP},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsMsgUser record);
}