package com.hai.dao;

import com.hai.entity.HighDiscountPackageDeliver;
import com.hai.entity.HighDiscountPackageDeliverExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighDiscountPackageDeliverMapper extends HighDiscountPackageDeliverMapperExt {
    @SelectProvider(type=HighDiscountPackageDeliverSqlProvider.class, method="countByExample")
    long countByExample(HighDiscountPackageDeliverExample example);

    @DeleteProvider(type=HighDiscountPackageDeliverSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighDiscountPackageDeliverExample example);

    @Delete({
        "delete from high_discount_package_deliver",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into high_discount_package_deliver (serial_number, package_id, ",
        "package_name, create_time, ",
        "`status`, op_user_id, ",
        "op_user_name, ext_1, ",
        "ext_2, ext_3)",
        "values (#{serialNumber,jdbcType=VARCHAR}, #{packageId,jdbcType=BIGINT}, ",
        "#{packageName,jdbcType=VARCHAR}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{status,jdbcType=INTEGER}, #{opUserId,jdbcType=BIGINT}, ",
        "#{opUserName,jdbcType=VARCHAR}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighDiscountPackageDeliver record);

    @InsertProvider(type=HighDiscountPackageDeliverSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighDiscountPackageDeliver record);

    @SelectProvider(type=HighDiscountPackageDeliverSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="serial_number", property="serialNumber", jdbcType=JdbcType.VARCHAR),
        @Result(column="package_id", property="packageId", jdbcType=JdbcType.BIGINT),
        @Result(column="package_name", property="packageName", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="op_user_id", property="opUserId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_user_name", property="opUserName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighDiscountPackageDeliver> selectByExample(HighDiscountPackageDeliverExample example);

    @Select({
        "select",
        "id, serial_number, package_id, package_name, create_time, `status`, op_user_id, ",
        "op_user_name, ext_1, ext_2, ext_3",
        "from high_discount_package_deliver",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="serial_number", property="serialNumber", jdbcType=JdbcType.VARCHAR),
        @Result(column="package_id", property="packageId", jdbcType=JdbcType.BIGINT),
        @Result(column="package_name", property="packageName", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="op_user_id", property="opUserId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_user_name", property="opUserName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    HighDiscountPackageDeliver selectByPrimaryKey(Long id);

    @UpdateProvider(type=HighDiscountPackageDeliverSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighDiscountPackageDeliver record, @Param("example") HighDiscountPackageDeliverExample example);

    @UpdateProvider(type=HighDiscountPackageDeliverSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighDiscountPackageDeliver record, @Param("example") HighDiscountPackageDeliverExample example);

    @UpdateProvider(type=HighDiscountPackageDeliverSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(HighDiscountPackageDeliver record);

    @Update({
        "update high_discount_package_deliver",
        "set serial_number = #{serialNumber,jdbcType=VARCHAR},",
          "package_id = #{packageId,jdbcType=BIGINT},",
          "package_name = #{packageName,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "op_user_id = #{opUserId,jdbcType=BIGINT},",
          "op_user_name = #{opUserName,jdbcType=VARCHAR},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(HighDiscountPackageDeliver record);
}