package com.hai.dao.order;

import com.hai.order.model.OrderCouponModal;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;
import java.util.Map;

/**
 * @className: OrderExtMapper
 * @author: HuRui
 * @date: 2022/8/26
 **/
public interface OrderMapperExt {

    /**
     * 查询用户购买卡券数据
     * @param userId
     * @param couponId
     * @return
     */
    @Select("SELECT count(1) FROM high_child_order where mem_id = #{userId} and child_order_status in (2,3) and goods_type = 1 and goods_id = #{couponId}")
    int userBuyCouponNum(@Param("userId") Long userId,@Param("couponId") Long couponId);

    /**
     * 查询卡券订单列表
     * @param param
     * @return
     */
    @Select("<script>" +
            " select" +
            " a.order_id orderId," +
            " a.order_no orderNo," +
            " b.pay_serial_no paySerialNo," +
            " a.id childOrderId," +
            " a.child_order_no childOrderNo," +
            " a.mem_phone memPhone," +
            " b.pay_gold integralDeduct," +
            " b.pay_type payType," +
            " a.goods_id goodsId," +
            " a.goods_name goodsName," +
            " a.goods_price goodsPrice," +
            " a.goods_actual_price goodsActualPrice," +
            " a.child_order_status childOrderStatus," +
            " a.create_time createTime," +
            " a.pay_time payTime," +
            " a.finish_time finishTime," +
            " a.cancel_time cancelTime," +
            " a.refund_time refundTime" +
            " from high_child_order a" +
            " LEFT JOIN high_order b on b.id = a.order_id" +
            " where a.goods_type = 1 and a.giveaway_type = 0" +
            " <if test='param.orderNo != null'> and a.order_no LIKE concat('%',#{param.orderNo},'%') </if>" +
            " <if test='param.paySerialNo != null'> and b.pay_serial_no LIKE concat('%',#{param.paySerialNo},'%') </if>" +
            " <if test='param.payType != null'> and a.pay_type = #{param.payType} </if>" +
            " <if test='param.childOrderNo != null'> and a.child_order_no = #{param.childOrderNo} </if>" +
            " <if test='param.memPhone != null'> and a.mem_phone = #{param.memPhone} </if>" +
            " <if test='param.goodsName != null'> and b.goods_name LIKE concat('%',#{param.goodsName},'%') </if>" +
            " <if test='param.childOrderStatus != null'> and b.child_order_status = #{param.childOrderStatus} </if>" +
            " <if test='param.createTimeS != null'> <![CDATA[ and a.create_time >= #{param.createTimeS} ]]> </if>" +
            " <if test='param.createTimeE != null'> <![CDATA[ and a.create_time <= #{param.createTimeE} ]]> </if>" +
            " <if test='param.payTimeS != null'> <![CDATA[ and a.pay_time >= #{param.payTimeS} ]]> </if>" +
            " <if test='param.payTimeE != null'> <![CDATA[ and a.pay_time <= #{param.payTimeE} ]]> </if>" +
            " <if test='param.refundTimeS != null'> <![CDATA[ and a.refund_time >= #{param.refundTimeS} ]]> </if>" +
            " <if test='param.refundTimeE != null'> <![CDATA[ and a.refund_time <= #{param.refundTimeE} ]]> </if>" +
            " ORDER BY a.create_time desc" +
            "</script>")
    List<OrderCouponModal> queryOrderCouponList(@Param("param") Map<String, Object> param);

}
